/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.NegaraDto;
import com.portofolio.service.NegaraService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/negara")
public class NegaraController extends LocaleController {
	@Lazy
	@Autowired
	private NegaraService negaraService;

	@ApiOperation("Api Untuk Menyimpan Negara")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody NegaraDto entity, HttpServletRequest request) {
		Map<String, Object> result = negaraService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Update Negara")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdNegara") Integer kdNegara,
			@RequestParam(value = "version") Integer version,
			@Valid @RequestBody NegaraDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = negaraService.update(entity,kdNegara,version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menghapus Negara BerdasarkanKdNegara")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdNegara") Integer kdNegara,
			@RequestParam(value = "version") Integer version) {
		Map<String, Object> result = negaraService.deleteByKode(kdNegara,version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Semua Negara")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = stringAsIntegerMaxValue) Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaNegara") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaNegara", required = false, defaultValue="") String namaNegara,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = negaraService.grid(page, rows, sort, dir, namaNegara,statusEnabled);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Negara Berdasarkan kdNegara")
	@GetMapping("/findByKdNegara")
	public ResponseEntity<Map<String, Object>> findByKode(
			@RequestParam(value = "kdNegara") Integer kdNegara) {
		Map<String, Object> result = negaraService.findByKdNegara(kdNegara);
		return RestUtil.getJsonResponse(result);
	}



}
